import { DeepPartial, DeleteResult, EntityManager, FindManyOptions, FindOneOptions, FindOptionsWhere, Repository, UpdateResult } from "typeorm";
export declare abstract class ServiceBase<Entity> {
    protected repo: Repository<Entity>;
    constructor(repo: Repository<Entity>);
    private get entity();
    findOneBy(options?: FindOneOptions<Entity>, manager?: EntityManager): Promise<Entity>;
    findAllBy(options?: FindManyOptions<Entity>, manager?: EntityManager): Promise<Entity[]>;
    createOneBy(params: DeepPartial<Entity>, manager?: EntityManager): Promise<Entity>;
    createAllBy(params: DeepPartial<Entity>[], manager?: EntityManager): Promise<Entity[]>;
    createOneIfNotExistBy(params: DeepPartial<Entity>, manager?: EntityManager): Promise<Entity>;
    createOrUpdateAllBy(params: DeepPartial<Entity>[], conflictPathsOrOptions: string[], manager?: EntityManager): Promise<Entity[]>;
    updateOneBy(where: string | number | Date | FindOptionsWhere<Entity>, set: {
        [K in keyof Entity]?: any;
    }, manager?: EntityManager): Promise<UpdateResult>;
    deleteOneBy(where?: FindOptionsWhere<Entity>, manager?: EntityManager): Promise<DeleteResult>;
}
